{%- import "src/_rda_template.j2" as rda_dmp_cs with context -%}
{%- import "src/_utils.j2" as utils with context -%}
{%- import "src/_tree_utils.j2" as tree with context -%}


{%- set local_ns = namespace(description="format") -%}



{%- macro setDistributionFormatRoot(globals, uuid) -%}
  {%- do globals.global_ns.dataset_vars.update({ "distribution_format_root" : uuid }) -%}

  {#- need to initialise -#}
  {%- do globals.global_ns.dataset_vars.update({ "distribution_format_physical_site_titles" : [] }) -%}
{%- endmacro -%}


{%- macro setDistributionFormatPhysicalSiteTitles(globals, entity, reply) -%}
  {{ utils.getPhysicalSiteTitles(entity, globals, "DistributionFormatPhysicalSiteNames", reply) }}
  {%- set titles = utils.global_ns.var_stack.pop() -%}
  {%- do globals.global_ns.dataset_vars.update({ "distribution_format_physical_site_titles" : titles }) -%}
{%- endmacro -%}






{%- macro processDatasetDistributionFormat(globals, dmp_being_built, reply, uuid)  -%}

  {%- set data_collection_names = globals.global_ns.dataset_vars.data_collection_names -%}
  {%- for name in data_collection_names -%}

    {#-    {{ " bioimagery_root " ~ globals.global_ns.dataset_vars.bioimagery_root ~ " " }}   -#}
    {#-    {{ " bioimagery_titles " ~ globals.global_ns.dataset_vars.bioimagery_titles ~ " " }}-#}
    {#-    {{ " cytometry_root " ~ globals.global_ns.dataset_vars.cytometry_root ~ " " }}-#}
    {#-   {{ " cytometry_titles " ~ globals.global_ns.dataset_vars.cytometry_titles ~ " " }}-#}
    {#-    {{ " genomics_root " ~ globals.global_ns.dataset_vars.genomics_root ~ " " }}-#}
    {#-    {{ " genomics_titles " ~ globals.global_ns.dataset_vars.genomics_titles ~ " " }}-#}
    {#-    {{ " proteomics_root " ~ globals.global_ns.dataset_vars.proteomics_root ~ " " }}-#}
    {#-    {{ " proteomics_titles " ~ globals.global_ns.dataset_vars.proteomics_titles ~ " " }}-#}
    {#-    {{ " metabolomics_root " ~ globals.global_ns.dataset_vars.metabolomics_root ~ " " }}-#}
    {#-    {{ " metabolomics_titles " ~ globals.global_ns.dataset_vars.metabolomics_titles ~ " " }}-#}

    {#-    {{ " uuid " ~ uuid ~ " " }}-#}
    
    
    {{ tree.isChildOf(globals, uuid, globals.global_ns.dataset_vars.distribution_format_root) }}
    {%- set answer_correct_item = tree.global_ns.var_stack.pop() -%}
    {%- if answer_correct_item -%}

      {%- if globals.global_ns.dataset_vars.distribution_format_physical_site_titles|length == 0 -%}
        {#- if distribution_format_physical_site_titles is empty, -#}
        {#- it means that there was no reply -#}
        {#- for sites, so this means all are concerned -#}
        {{ setDistributionFormatPhysicalSiteTitles(globals, none, none) }}
      {%- endif -%}
      {%- set physical_site_titles = globals.global_ns.dataset_vars.distribution_format_physical_site_titles -%}

      {{ tree.isChildOf(globals, uuid, globals.global_ns.dataset_vars.bioimagery_root) }}
      {%- set answer = tree.global_ns.var_stack.pop() -%}
      {%- if answer -%}
        {{ utils.getDatasetsFromNamesAndDisciplines(globals, dmp_being_built,
        globals.global_ns.dataset_vars.bioimagery_titles, [name]) }}
        {%- set datasets = utils.global_ns.var_stack.pop()  -%}
        
        {%- for dataset in datasets -%}
          {%- set sites = dataset.distribution -%}
          {%- set nb_sites = sites|length -%}
          {%- for i in range(nb_sites) -%}
            {%- if sites[i].title in physical_site_titles -%}
              {%- set site = dataset.distribution[i] -%}
              {%- do site.format.append(reply) -%}
            {%- endif -%}
          {%- endfor -%}
        {%- endfor -%}
      {%- endif -%}

      {{ tree.isChildOf(globals, uuid, globals.global_ns.dataset_vars.metabolomics_root) }}
      {%- set answer = tree.global_ns.var_stack.pop() -%}
      {%- if answer -%}
        {{ utils.getDatasetsFromNamesAndDisciplines(globals, dmp_being_built,
        globals.global_ns.dataset_vars.metabolomics_titles, [name]) }}
        {%- set datasets = utils.global_ns.var_stack.pop()  -%}
        
        {%- for dataset in datasets -%}
          {%- set sites = dataset.distribution -%}
          {%- set nb_sites = sites|length -%}
          {%- for i in range(nb_sites) -%}
            {%- if sites[i].title in physical_site_titles -%}
              {%- set site = dataset.distribution[i] -%}
              {%- do site.format.append(reply) -%}
            {%- endif -%}
          {%- endfor -%}
        {%- endfor -%}
      {%- endif -%}

      {{ tree.isChildOf(globals, uuid, globals.global_ns.dataset_vars.cytometry_root) }}
      {%- set answer = tree.global_ns.var_stack.pop() -%}
      {%- if answer -%}
        {{ utils.getDatasetsFromNamesAndDisciplines(globals, dmp_being_built,
        globals.global_ns.dataset_vars.cytometry_titles, [name]) }}
        {%- set datasets = utils.global_ns.var_stack.pop()  -%}
        
        {%- for dataset in datasets -%}
          {%- set sites = dataset.distribution -%}
          {%- set nb_sites = sites|length -%}
          {%- for i in range(nb_sites) -%}
            {%- if sites[i].title in physical_site_titles -%}
              {%- set site = dataset.distribution[i] -%}
              {%- do site.format.append(reply) -%}
            {%- endif -%}
          {%- endfor -%}
        {%- endfor -%}
      {%- endif -%}

      {{ tree.isChildOf(globals, uuid, globals.global_ns.dataset_vars.genomics_root) }}
      {%- set answer = tree.global_ns.var_stack.pop() -%}
      {%- if answer -%}
        {{ utils.getDatasetsFromNamesAndDisciplines(globals, dmp_being_built,
        globals.global_ns.dataset_vars.genomics_titles, [name]) }}
        {%- set datasets = utils.global_ns.var_stack.pop()  -%}
        
        {%- for dataset in datasets -%}
          {%- set sites = dataset.distribution -%}
          {%- set nb_sites = sites|length -%}
          {%- for i in range(nb_sites) -%}
            {%- if sites[i].title in physical_site_titles -%}
              {%- set site = dataset.distribution[i] -%}
              {%- do site.format.append(reply) -%}
            {%- endif -%}
          {%- endfor -%}
        {%- endfor -%}
      {%- endif -%}

      {{ tree.isChildOf(globals, uuid, globals.global_ns.dataset_vars.proteomics_root) }}
      {%- set answer = tree.global_ns.var_stack.pop() -%}
      {%- if answer -%}
        {{ utils.getDatasetsFromNamesAndDisciplines(globals, dmp_being_built,
        globals.global_ns.dataset_vars.proteomics_titles, [name]) }}
        {%- set datasets = utils.global_ns.var_stack.pop()  -%}
        
        {%- for dataset in datasets -%}
          {%- set sites = dataset.distribution -%}
          {%- set nb_sites = sites|length -%}
          {%- for i in range(nb_sites) -%}
            {%- if sites[i].title in physical_site_titles -%}
              {%- set site = dataset.distribution[i] -%}
              {%- do site.format.append(reply) -%}
            {%- endif -%}
          {%- endfor -%}
        {%- endfor -%}
      {%- endif -%}

      {{ tree.isChildOf(globals, uuid, globals.global_ns.dataset_vars.other_data_root) }}
      {%- set answer = tree.global_ns.var_stack.pop() -%}
      {%- if answer -%}
        {{ utils.getDatasetsFromNamesAndDisciplines(globals, dmp_being_built,
        globals.global_ns.dataset_vars.other_data_titles, [name]) }}
        {%- set datasets = utils.global_ns.var_stack.pop()  -%}
        
        {%- for dataset in datasets -%}
          {%- set sites = dataset.distribution -%}
          {%- set nb_sites = sites|length -%}
          {%- for i in range(nb_sites) -%}
            {%- if sites[i].title in physical_site_titles -%}
              {%- set site = dataset.distribution[i] -%}
              {%- do site.format.append(reply) -%}
            {%- endif -%}
          {%- endfor -%}
        {%- endfor -%}
      {%- endif -%}
    {%- endif -%}
  {%- endfor -%}
{%- endmacro -%}


